.envrc 6.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240
  1. # This is the .envrc for sentry, for use with direnv.
  2. # It's responsible for enforcing a standard dev environment by checking as much state as possible, and either performing
  3. # initialization (e.g. activating the venv) or giving recommendations on how to reach the desired state.
  4. # It also sets useful environment variables.
  5. # If you'd like to override or set any custom environment variables, this .envrc will read a .env file at the end.
  6. set -e
  7. bold="$(tput bold)"
  8. red="$(tput setaf 1)"
  9. green="$(tput setaf 2)"
  10. yellow="$(tput setaf 3)"
  11. reset="$(tput sgr0)"
  12. # XXX: we can't trap bash EXIT, because it'll override direnv's finalizing routines.
  13. # consequently, using "exit" anywhere will skip this notice from showing.
  14. # so need to use set -e, and return 1.
  15. trap notice ERR
  16. # This is used to group issues on Sentry.io.
  17. # If an issue does not call info() or die() it will be grouped under this
  18. error_message="Unknown issue"
  19. log_level="info"
  20. notice() {
  21. [ $? -eq 0 ] && return
  22. cat <<EOF
  23. ${red}${bold}direnv wasn't able to complete execution.
  24. You may have been given some recommendations in the error message.
  25. Follow them, and then you'll need to redo direnv by running "direnv allow".${reset}
  26. If you're stuck or have questions, ask in #discuss-dev-tooling.
  27. EOF
  28. [ -z "${SENTRY_DEVENV_NO_REPORT+x}" ] && report_to_sentry
  29. }
  30. report_to_sentry() {
  31. if ! require sentry-cli; then
  32. curl -sL https://sentry.io/get-cli/ | bash
  33. fi
  34. SENTRY_DSN=${SENTRY_DEVENV_DSN} \
  35. sentry-cli send-event -m "$error_message" --logfile "$_SENTRY_LOG_FILE" --level $log_level
  36. rm "$_SENTRY_LOG_FILE"
  37. }
  38. require() {
  39. command -v "$1" >/dev/null 2>&1
  40. }
  41. warn() {
  42. cat <<EOF
  43. ${yellow}${bold}direnv: ${@}${reset}
  44. EOF
  45. }
  46. info() {
  47. cat <<EOF
  48. ${bold}direnv: ${@}${reset}
  49. EOF
  50. # info() calls happen multiple times in this script. The last info statement
  51. # is the one that will be used to group Sentry issues
  52. error_message=( "${@}" )
  53. }
  54. die() {
  55. cat >&2 <<EOF
  56. ${red}${bold}direnv FATAL: ${@}
  57. ${reset}
  58. EOF
  59. # When reporting to Sentry, this will allow grouping the errors differently
  60. # NOTE: The first line of the output is used to group issues
  61. error_message=( "${@}" )
  62. log_level="error"
  63. return 1
  64. }
  65. advice_init_venv() {
  66. venv_name="$1"
  67. deactivate 2>/dev/null || true
  68. info "To create a virtualenv, please type: python3.6 -m venv ${venv_name}"
  69. require "python3.6" ||
  70. die "You'll need to install python3, or make it available on your PATH.
  71. It's recommended to use pyenv - please refer to https://docs.sentry.io/development/contribute/environment"
  72. return 1
  73. }
  74. advice_install_sentry() {
  75. info "To install sentry, please type: make install-py-dev"
  76. return 1
  77. }
  78. advice_install_pre_commit() {
  79. info "To install pre-commit, please type: make setup-git"
  80. return 1
  81. }
  82. advice_install_yarn_pkgs() {
  83. info "To install yarn packages, please type: make install-js-dev"
  84. return 1
  85. }
  86. ### Environment ###
  87. # don't write *.pyc files; using stale python code occasionally causes subtle problems
  88. export PYTHONDONTWRITEBYTECODE=1
  89. # Always write stdout immediately. Very helpful for debugging
  90. export PYTHONUNBUFFERED=1
  91. # make sure we don't have any conflicting PYTHONPATH
  92. unset PYTHONPATH
  93. # don't check pypi for a potential new pip version; low-hanging fruit to save a bit of time
  94. export PIP_DISABLE_PIP_VERSION_CHECK=on
  95. # increase node's memory limit, required for our webpacking
  96. export NODE_OPTIONS=--max-old-space-size=4096
  97. # Frontend hot module reloader using `react-refresh`
  98. # Enable this by default for development envs (CI/deploys do not use envrc)
  99. export SENTRY_UI_HOT_RELOAD=1
  100. ### You can override the exported variables with a .env file
  101. # All exports should happen before here unless they're safeguarded (see devenv error reporting below)
  102. if [ -f '.env' ]; then
  103. info ".env found. Reading it..."
  104. dotenv .env
  105. fi
  106. ## Notify of reporting to Sentry
  107. if [ -n "${SENTRY_DEVENV_NO_REPORT+x}" ]; then
  108. info "No development environment errors will be reported (since you've defined SENTRY_DEVENV_NO_REPORT)."
  109. else
  110. # Since direnv traps the EXIT signal we place the temp file under /tmp for the odd time
  111. # the script will use the EXIT path
  112. _SENTRY_LOG_FILE=$(mktemp /tmp/sentry.envrc.$$.out || mktemp /tmp/sentry.envrc.XXXXXXXX.out)
  113. exec > >(tee "$_SENTRY_LOG_FILE")
  114. exec 2>&1
  115. info "Development errors will be reported to Sentry.io."$'\n'" If you wish to opt-out, set SENTRY_DEVENV_NO_REPORT as an env variable."
  116. export SENTRY_DEVENV_DSN=https://23670f54c6254bfd9b7de106637808e9@o1.ingest.sentry.io/1492057
  117. fi
  118. ### System ###
  119. for pkg in \
  120. make \
  121. docker \
  122. chromedriver \
  123. pkg-config \
  124. pyenv \
  125. openssl; do
  126. if ! require "$pkg"; then
  127. die "You seem to be missing the system dependency: ${pkg}
  128. Please install homebrew, and run brew bundle."
  129. fi
  130. done
  131. ### Git ###
  132. info "Configuring git..."
  133. make setup-git-config
  134. ### Python ###
  135. venv_name=".venv"
  136. info "Activating virtualenv..."
  137. if [ ! -f "${venv_name}/bin/activate" ]; then
  138. info "You don't seem to have a virtualenv."
  139. # If the version doesn't match the contents of .python-version it will fail
  140. [[ $(pyenv version) ]] || \
  141. die "pyenv does not have the right Python version installed. Please run:
  142. make setup-pyenv && python3.6 -m venv ${venv_name}"
  143. advice_init_venv "$venv_name"
  144. fi
  145. # The user might be cd'ing into sentry with another non-direnv managed
  146. # (in that it would be automatically deactivated) virtualenv active.
  147. deactivate 2>/dev/null || true
  148. source "${venv_name}/bin/activate"
  149. # XXX: ideally, direnv is able to export PS1 as modified by sourcing venvs
  150. # but we'd have to patch direnv, and ".venv" isn't descriptive anyways
  151. unset PS1
  152. info "Ensuring proper virtualenv..."
  153. ${PWD}/scripts/ensure-venv.sh
  154. if ! require sentry; then
  155. info "Your virtualenv is activated, but sentry doesn't seem to be installed."
  156. # XXX: if direnv fails, the venv won't be activated outside of direnv execution...
  157. # So, it is critical that make install-py-dev is guarded by scripts/ensure-venv.
  158. advice_install_sentry
  159. fi
  160. ### pre-commit ###
  161. info "Checking pre-commit..."
  162. if ! require pre-commit; then
  163. info "Looks like you don't have pre-commit installed."
  164. advice_install_pre_commit
  165. fi
  166. ### Node ###
  167. info "Checking node..."
  168. if ! require node; then
  169. die "You don't seem to have node installed. Install volta (a node version manager): https://develop.sentry.dev/environment/#javascript"
  170. fi
  171. make node-version-check
  172. if [ ! -x "node_modules/.bin/webpack" ]; then
  173. info "You don't seem to have yarn packages installed."
  174. advice_install_yarn_pkgs
  175. fi
  176. PATH_add node_modules/.bin
  177. ### Overrides ###
  178. cat <<EOF
  179. ${green}${bold}direnv: SUCCESS!
  180. ${reset}
  181. EOF
  182. if [ -z "${SENTRY_SILENCE_DIRENV_NOTICE:-}" ]; then
  183. cat <<EOF
  184. If you're stuck or have questions, ask in #discuss-dev-tooling.
  185. EOF
  186. fi
  187. # Since we can't use an EXIT routine we need to guarantee we delete the file here
  188. rm -f "$_SENTRY_LOG_FILE"